/*
Ultima 4 World Map Editor v1.1

Copyright 2011 Matthew Duncan

This file is part of the Ultima 4 World Map Editor v1.1.

Ultima 4 World Map Editor v1.1 is free software: you can redistribute it and/or
modify it under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your option)
any later version.

Ultima 4 World Map Editor v1.1 is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License
along with Ultima 4 World Map Editor v1.1. If not, see
<http://www.gnu.org/licenses/>.
*/
#define GModeW 640
#define GModeH 480
#define MAX_TILES 256
#define TILE_SIZE 16
#define SHAPE_FILE_SIZE 32768
#define MAP_FILE_SIZE 65536
#define CURSOR_PIC_SIZE 18
#define PLOT_OFFSET 16
#define X_ORIGIN 0
#define Y_ORIGIN 0
#define TILE_BYTES 128
#define COMBAT_FILE_SIZE 192
#define TEXT_X 250
#define TEXT_Y 50
#define MAX_COMBAT_FILES 24
/* defines */
#define InstX 320
#define InstY 309
#define MAPMIN 0
#define MAPMAX 30
#define EDITMIN 0
#define EDITMAX 15
#define UP 1
#define DOWN 2
#define LEFT 3
#define RIGHT 4
#define CURSOROFF 17
#define LINELENGTH 256
#define CURSORSIZE 8
#define TILEBLOCKSIZE 128
#define MAPBASEX 35
#define MAPBASEY 20
#define EDITBASEX 329
#define EDITBASEY 20
#define MAPSELECTOFF 259
#define EDITSELECTOFF 274
#define TILESPERLINE 16
#define MAXEDITTILES 52
#define BYTESPERPIC 1028
#define FILESIZE 65536
#define EDITTILEX 52
#define EDITTILEY 366
#define EDIT_TILE_INC 24
#define PICSIZE 16
#define BLACK 0
#define WHITE 15
#define RED 116
/* globals */
BITMAP *Tiles[MAX_TILES], *MapCursorPic, *Screenbuff;
RGB UpgradePalette[256];
//extern FONT *font;
unsigned int MapX, MapY;
unsigned int EditX, EditY;
int CursorToggle, EditFlag;
char *Map, *MapBuffer;
int TilePixelColour[MAXEDITTILES] = {49,9,25,3,98,82,66,79,47,101,56,116,104,116,116,116,246,245,54,77,54,54,130,130,104,117,68,57,57,57,57,70,70,114,63,68,68,6,117,68,70,26,41,56,45,15,31,110,124,152,0,31};
int TileNumberArray[MAXEDITTILES] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,22,23,24,25,26,27,28,29,30,48,49,50,51,52,53,54,55,57,58,59,60,61,62,63,68,69,70,71,72,73,74,75,76,126,127};
char *TileLetters = "qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM";
/* user funcs */
void U4File2Map(char *U4File, char *MapFile);
void Map2U4File(char *U4File, char *MapFile);
int SaveMap(void);
void RestoreMap(void);
void DrawMapSelectFrame(int X, int Y, int SIZE, int STAT);
int InitVars(void);
int LoadMap(void);
int LoadTiles(void);
void ReadMapCursor(void);
int MoveCursor(int CurrPos, int Direction, int MINVal, int MAXVal);
void DrawMapCursor(void);
void EraseMapCursor(void);
void DrawEditCursor(void);
void EraseEditCursor(void);
int ToggleCursor(int CurrStatus);
void PaintMaps(void);
void EditScreen(int TileNumber);
void PaintEditTiles(void);
int Map2Pixel(int TileNum);
//int SaveFile(void);
